% by Seungmoon Song
% Feb. 2014

function animUpdate(tree)

    global SegObjects SegShape
    n_seg = 29;
    
    for i = 1:n_seg
        pos_w   = tree.j(i).position_w;
        ori_R  	= tree.l(i).orientation;
        RotTransObj3(SegObjects(i), SegShape(i), pos_w, ori_R);
    end
    
    
end




function RotTransObj3(Object, Shape, pos_w, ori_R)    
        
    % reshape Shape
    [row, col] = size(Shape.x);
    oShape = [reshape(Shape.x, 1, row*col);reshape(Shape.y, 1, row*col);reshape(Shape.z, 1, row*col)];    
     
    nShape = ori_R*oShape;
    
    xx = reshape(nShape(1,:), row, col);
    yy = reshape(nShape(2,:), row, col);
    zz = reshape(nShape(3,:), row, col);

    % update object
    set(Object, 'XData', xx + pos_w(1));
    set(Object, 'YData', yy + pos_w(2));
    set(Object, 'ZData', zz + pos_w(3));
    
end